rng(54,"twister")

% Data for simulation
InversionParameters.nbsim = 1;   % Number of simulation
InversionParameters.seed = 89456; % Seed generator
InversionParameters.nl = 4000;   % numbers of lines 
InversionParameters.c = 0.25;     % Variogram sill
InversionParameters.ap = 50;     % minor axis
InversionParameters.ag = 50;     % major axis
InversionParameters.theta = 0;   % anisotropic angle
InversionParameters.nx = 200;    % Field size in x-direction
InversionParameters.ny = 200;    % Field size in y-direction
InversionParameters.nz = 1;      % Field size in z-direction

Zref = SimulationProcess(InversionParameters);

%%
FlowParameters.nx    = InversionParameters.nx;
FlowParameters.ny    = InversionParameters.ny;
FlowParameters.Z     = Zref;
FlowParameters.BC    = [0 ; 1];
FlowParameters.Kmean = 100;

Rref=FlowSimulation(FlowParameters);
%%

save('Reference_Data.mat','Zref','Rref')

figure(1);clf;
imagesc(reshape(Rref,[nx ny])');
axis('square')
xlabel('Coord. x (m)')
ylabel('Coord. y (m)')
title('Carte des charges hydrauliques')
colorbar;
colormap jet;
clim([0 1]);
set(gca, 'YDir', 'normal');
fontsize(gca, 12, 'points');

figure(2);clf;
imagesc(reshape(Zref,[nx ny])');
axis('square')
xlabel('Coord. x (m)')
ylabel('Coord. y (m)')
title('Log10 Transmissivité')
colorbar;
colormap jet;
clim([-2 2]);
set(gca, 'YDir', 'normal');
fontsize(gca, 12, 'points');