%% Loading Data
rng(4512,"twister")
% Grid Data
nx=200; ny=200;nz=1;
x0=grille3(1,nx,1,1,ny,1,1,nz,1);
seed=85632;

%Piezometer location
x0Piezo=[];
x0Piezo(:,1)=nx/2 + [8 ; -16 ; -8  ;  16 ; 4 ; -4 ;...
                0  ;   0 ;  0  ;  0 ; 0 ; 0  ;...
                24 ;  24 ; -24 ; -24  ;...
                0  ;   0 ;  24 ; -24  ]*3;

x0Piezo(:,2)=ny/2 + [0 ;   0 ;   0 ;  0;  0 ; 0  ;...
                8 ; -16 ;  -8 ;  16; 4 ; -4 ;...
                24 ; -24 ; -24 ;  24 ;...
                24 ; -24 ;   0 ;   0  ]*3;
%Piezometer Index
LocData=nx*(x0Piezo(:,2)-1)+x0Piezo(:,1);

% Meeasurement errors
load('Reference_Data.mat')
error=randn(length(LocData),1)*0.05;

RrefData=Rref;
RrefData(LocData,:)=RrefData(LocData,:)+error;

% Initialization of FlowParameters. Initial guest
FlowParameters.nx      = nx;
FlowParameters.ny      = ny;
FlowParameters.Z       = [];
FlowParameters.BC      = [0 1];
FlowParameters.Kmean   = 100;
FlowParameters.href    = RrefData;
FlowParameters.LocData = LocData;

% Initialization of FlowParameters. Initial guest

model = [4 50 50 50 0 0 0]; c = 0.25;
nbsim=1; nl =500;
MaxIter = 3;
OFmin = 0.01;
seed = 124512514;

tic
[Z,Err,Delta,Phi,Iter] = SSTBM(x0,model,c,nbsim,nl,MaxIter,OFmin,seed,FlowParameters);
t_MRST=toc;
save('ZInv.mat','Z', 'Err','Delta','Phi','Iter')


